//TODO: 2006.12.11 int -> void etc. check return values. 

// algebra part
#include <gmpxx.h>
#include <vector>
#include <algorithm>

#ifndef _MAIN_
#define EXTERN extern
#else
#define EXTERN
#endif

EXTERN gmp_randclass *uniformrandom;

#ifdef __cplusplus
extern "C"{
#endif

mpf_class gmp_randomnumber(void);

void gmp_setrandvec (int N, mpf_class *p);
void gmp_setrandmat (int N, int M, mpf_class *p);
void gmp_setrandsymmmat (int N, mpf_class *p);
void gmp_setrandumat (int N, mpf_class *p);
void gmp_setrandlmat (int N, mpf_class *p);

void gmp_printvec (int N, mpf_class *A);
void gmp_printmat (int N, int M, mpf_class *A, int LDA);
void gmp_printsymmmat (int N, mpf_class *A, int LDA);
void gmp_printmat3 (int N, mpf_class *p, mpf_class *q);

int gmp_dgemmNN(int M, int N, int K, mpf_class alpha, mpf_class *A, int LDA, mpf_class *B, int LDB, mpf_class beta, mpf_class *C, int LDC);
int gmp_dgemmNT(int M, int N, int K, mpf_class alpha, mpf_class *A, int LDA, mpf_class *B, int LDB, mpf_class beta, mpf_class *C, int LDC);
int gmp_dgemmTT(int M, int N, int K, mpf_class alpha, mpf_class *A, int LDA, mpf_class *B, int LDB, mpf_class beta, mpf_class *C, int LDC);
int gmp_dgemmTN(int M, int N, int K, mpf_class alpha, mpf_class *A, int LDA, mpf_class *B, int LDB, mpf_class beta, mpf_class *C, int LDC);

void gmp_dlae2(mpf_class a, mpf_class b, mpf_class c, mpf_class *rt1, mpf_class *rt2);
int gmp_dtrsmRLTN(int M, int N, mpf_class alpha, mpf_class *A, int LDA, mpf_class *B, int LDB);
int gmp_dtrsmLLTN(int M, int N, mpf_class alpha, mpf_class *A, int LDA, mpf_class *B, int LDB);
int gmp_dtrsvUN(int N, mpf_class *A, int LDA, mpf_class *x, int incx);
int gmp_dtrsvLN(int N, mpf_class *A, int LDA, mpf_class *x, int incx);
int gmp_dtrsvUT(int N, mpf_class *A, int LDA, mpf_class *x, int incx);
int gmp_dtrsvLT(int N, mpf_class *A, int LDA, mpf_class *x, int incx);
int gmp_dtrmvUN(int N, mpf_class *A, int LDA, mpf_class *x, int incx);
int gmp_dtrmvUT(int N, mpf_class *A, int LDA, mpf_class *x, int incx);
int gmp_dtrmvLN(int N, mpf_class *A, int LDA, mpf_class *x, int incx);
int gmp_dtrmvLT(int N, mpf_class *A, int LDA, mpf_class *x, int incx);
void gmp_dcopy(int N, mpf_class *X, int incx, mpf_class *Y, int incy);
int gmp_dgemvN(int M, int N, mpf_class alpha, mpf_class *A, int LDA, mpf_class *x, int incx, mpf_class beta, mpf_class *y, int incy);
int gmp_dgemvT(int M, int N, mpf_class alpha, mpf_class *A, int LDA, mpf_class *x, int incx, mpf_class beta, mpf_class *y, int incy);

void gmp_clearumat (int N, mpf_class *p, int LDA);
void gmp_clearlmat (int N, mpf_class *p, int LDA);

mpf_class gmp_ddot(int n, mpf_class *dx, int incx, mpf_class *dy, int incy);
int gmp_dsytrd_old(int N, mpf_class *A, int LDA, mpf_class *D, mpf_class *E);
int gmp_dpotrfL(int N, mpf_class *A, int LDA);
int gmp_dpotrfLi(int N, mpf_class *A, int LDA);
int gmp_dpotrfU(int N, mpf_class *A, int LDA);
mpf_class gmp_dnrm2(int N, mpf_class *x, int inc);
int gmp_dscal(int N, mpf_class alpha, mpf_class *X, int inc);
mpf_class gmp_dlapy2(mpf_class x, mpf_class y);
mpf_class gmp_dlamchE(void);
mpf_class gmp_dlamchP(void);
mpf_class gmp_dlamchB(void);
mpf_class gmp_dlamchS(void);
mpf_class gmp_sign(mpf_class a, mpf_class b);
void gmp_dlarfg(int N, mpf_class *alpha, mpf_class *x, int incx, mpf_class *tau);
void gmp_dsyr2U(int N, mpf_class alpha, mpf_class *x, int incx, mpf_class *y, int incy, mpf_class *A, int LDA);
void gmp_dsyr2L(int N, mpf_class alpha, mpf_class *x, int incx, mpf_class *y, int incy, mpf_class *A, int LDA);
void gmp_dsymvL(int N, mpf_class alpha, mpf_class *A, int LDA, mpf_class *x, int incx, mpf_class beta, mpf_class *y, int incy);
void gmp_dsymvU(int N, mpf_class alpha, mpf_class *A, int LDA, mpf_class *x, int incx, mpf_class beta, mpf_class *y, int incy);
void gmp_dsytrdU(int N, mpf_class *A, int LDA, mpf_class *d, mpf_class *e, mpf_class *tau);
void gmp_dsytrdL(int N, mpf_class *A, int LDA, mpf_class *d, mpf_class *e, mpf_class *tau);
int gmp_daxpy(int N, mpf_class alpha, mpf_class *X, int incx, mpf_class *Y, int incy);
void gmp_swapvec(int dim, mpf_class *a, int inca, mpf_class *b, int incb);
void gmp_swap(mpf_class *a, mpf_class *b);
void gmp_sortvecA(int dim, mpf_class *a);
mpf_class gmp_dlanstI(int N, mpf_class *D, mpf_class *E);
int gmp_dsterf(int N, mpf_class *D, mpf_class *E);
void gmp_dlaev2(mpf_class a, mpf_class b, mpf_class c, mpf_class *rt1, mpf_class *rt2, mpf_class *cs1, mpf_class *sn1);
void gmp_dlartg(mpf_class f, mpf_class g, mpf_class *cs, mpf_class *sn, mpf_class *r);
void gmp_dswap(int N, mpf_class *dx, int incx, mpf_class *dy, int incy);
void gmp_dlasetF(int M, int N, mpf_class alpha, mpf_class beta, mpf_class *A, int LDA);
int gmp_dlasrRVB(int M, int N, mpf_class *C, mpf_class *S, mpf_class *A, int LDA);
int gmp_dlasrRVF(int M, int N, mpf_class *C, mpf_class *S, mpf_class *A, int LDA);
int gmp_dsteqrI(int N, mpf_class *D, mpf_class *E, mpf_class *Z, int LDZ, mpf_class *work);
mpf_class gmp_dlansyML(int N, mpf_class *A, int LDA);
int gmp_dsyevVL(int N, mpf_class *A, int LDA, mpf_class *W, mpf_class *work, int lwork);
int gmp_dsyevNL(int N, mpf_class *A, int LDA, mpf_class *W, mpf_class *work, int lwork);
void gmp_dset(int N, mpf_class a, mpf_class* x, int step);
int gmp_dtrmmLUNN(int M, int N, mpf_class alpha, mpf_class *A, int LDA, mpf_class *B, int LDB);
int gmp_dtrmmLLTN(int M, int N, mpf_class alpha, mpf_class *A, int LDA, mpf_class *B, int LDB);
int gmp_dtrsmLLNN(int M, int N, mpf_class alpha, mpf_class *A, int LDA, mpf_class *B, int LDB);

#ifndef max
#define max(a,b) (((a)>(b))?(a):(b))
#endif
#ifndef min
#define min(a,b) (((a)<(b))?(a):(b))
#endif

//In some case we need this hellish hack
inline mpf_class mpf_abs_(mpf_class a)
{
  if(a>=0.0) return a;
  else return -a;
}


#ifdef __cplusplus
}
#endif
